
%define name	openxp
%define version	5.0.50
%define release	1

%define sPath	-Funetcall -Fuobjcom -Fuxplib 
%define sPathI	-FuIndy10/Lib/System -FuIndy10/Lib/Core -FuIndy10/Lib/Protocols

%define prefix	/usr/local/lib/openxp

%ifarch x86_64
  %define ppcname ppcx64
  %else
  %define ppcname ppc386
%endif

Summary: A console-mode multi-net, multi-protocol mail/news application

Name:	 %{name}
Version: %{version}
Release: %{release}
License: GPLv2
Group:   Applications/Internet
Url:     http://sourceforge.net/projects/openxp5/

Source: %{name}-%{version}.src.tar.gz
Patch0:	Indy10.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

Requires: openssl

BuildRequires:	fpc >= 2.6.2
BuildRequires:	%{_lib}ncursesw-devel

%description
# maximum line length = 70 chars
Console-mode multi-platform and multi-protocol mail/news
application supporting POP3, SMTP, IMAP, NNTP, UUCP,
FidoNet and ZConnect. FidoNet protocols supported are binkP
(Fido-over-IP) and POTS. POP3/SMTP/IMAP now support SSL/TLS.
Online help and user interface available in German and English.

%prep

%setup -q -n %{name}-%{version}.src

cd Indy10
%patch0 -p1

%build

%{ppcname} -B %{sPath} %{sPathI} openxp
%{ppcname} %{sPath} %{sPathI} rc
%{ppcname} %{sPath} %{sPathI} ihs

./rc openxp-d.rq
./rc openxp-e.rq
./ihs doc/openxp-d.ihq
./ihs doc/openxp-e.ihq

%install
rm -fr %{buildroot}

# create directories
mkdir -p %{buildroot}%{prefix}
mkdir -p %{buildroot}%{prefix}/bin
mkdir -p %{buildroot}%{prefix}/lib
mkdir -p %{buildroot}%{prefix}/doc
mkdir -p %{buildroot}%{prefix}/beispiel
mkdir -p %{buildroot}%{prefix}/samples
mkdir -p %{buildroot}%{prefix}/License

# copy the binary
cp openxp %{buildroot}%{prefix}/bin

# copy the resources
cp openxp*.res %{buildroot}%{prefix}/lib

# copy the docs, help files and description file
%ifnarch x86_64
  cp dist/linux/doc/file_id.diz %{buildroot}%{prefix}/doc
  %else
  cp dist/linux/doc/x86_64/file_id.diz %{buildroot}%{prefix}/doc
%endif

cp dist/linux/doc/distros.txt %{buildroot}%{prefix}/doc
cp dist/linux/doc/fido.txt %{buildroot}%{prefix}/doc
cp dist/linux/doc/openxp.html %{buildroot}%{prefix}/doc
cp dist/linux/doc/oxpguide.pdf %{buildroot}%{prefix}/doc
cp dist/linux/doc/uucp.txt %{buildroot}%{prefix}/doc
cp dist/linux/doc/xpoint.txt %{buildroot}%{prefix}/doc
cp doc/*.hlp %{buildroot}%{prefix}/doc

# copy example GERMAN scripts and templates
cp beispiel/* %{buildroot}%{prefix}/beispiel

# copy example ENGLISH templates
cp samples/* %{buildroot}%{prefix}/samples

# copy the licences
cp License/* %{buildroot}%{prefix}/License

# copy "XP" icon
cp dist/linux/icons/xp.png %{buildroot}%{prefix}/lib

%pre

%post
# create symlinks
ln -sf %{prefix}/bin/openxp /usr/local/bin/xp
ln -sf %{prefix}/bin/openxp /usr/local/bin/openxp

%preun

%postun
# remove everything apart from ~/.openxp
rm -rf %{prefix}
rm -f /usr/local/bin/openxp
rm -f /usr/local/bin/xp

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)

# install binary
%{prefix}/bin/openxp

# install resources
%{prefix}/lib/openxp-d.res
%{prefix}/lib/openxp-e.res

# install docs, help files and description file
%{prefix}/doc/*.txt
%{prefix}/doc/*.html
%{prefix}/doc/*.pdf
%{prefix}/doc/*.hlp
%{prefix}/doc/file_id.diz

# install example GERMAN scripts and templates
%{prefix}/beispiel/*

# install example ENGLISH templates
%{prefix}/samples/*

# install the licences
%{prefix}/License/*

# install "XP" icon
%{prefix}/lib/xp.png

%changelog
* Sat May 22 2021 M.E.Foster <mf at openxp dot uk> 5.0.50-1
- New version (5.0.50)

* Sat Feb 20 2021 M.E.Foster <mf at openxp dot uk> 5.0.49-1
- New version (5.0.49)

* Sun Dec 27 2020 M.E.Foster <mf at openxp dot uk> 5.0.48-1
- New version (5.0.48)

* Wed Oct 07 2020 M.E.Foster <mf at openxp dot uk> 5.0.47-1
- Compiler rolled back to 3.0.4

* Tue Oct 06 2020 M.E.Foster <mf at openxp dot uk> 5.0.47-1
- Development build
- Compiler updated to 3.2.0

* Sat Aug 29 2020 M.E.Foster <mf at openxp dot uk> 5.0.46-1
- New version (5.0.46)

* Sat Dec 28 2019 M.E.Foster <mf at openxp dot uk> 5.0.42-1
- New version (5.0.42)

* Sat Jul 20 2019 M.E.Foster <mf at openxp dot uk> 5.0.40-1
- New version (5.0.40)

* Thu Jun 27 2019 M.E.Foster <mf at openxp dot uk> 5.0.39-1
- Development build (5.0.39)

* Mon Apr 08 2019 M.E.Foster <mf at openxp dot uk> 5.0.38-1
- New version (5.0.38)

* Sat Apr 06 2019 M.E.Foster <mf at openxp dot uk> 5.0.37-1
- New version (5.0.37)

* Fri Jan 11 2019 M.E.Foster <mf at openxp dot uk> 5.0.36-1
- New version (5.0.36)

* Sat Dec 29 2018 M.E.Foster <mf at openxp dot uk> 5.0.35-1
- New version (5.0.35)

* Sun Nov 04 2018 M.E.Foster <mf at openxp dot uk> 5.0.34-2
- Development build
- Compiler updated to 3.0.4

* Sat Mar 10 2018 M.E.Foster <mf at openxp dot uk> 5.0.34-1
- New version (5.0.34)

* Sat Jan 06 2018 M.E.Foster <mf at openxp dot uk> 5.0.33-2
- Development build
- Indy10 libraries updated to revision 5444

* Wed Dec 27 2017 M.E.Foster <mf at openxp dot uk> 5.0.33-1
- New version (5.0.33)

* Sat Sep 30 2017 M.E.Foster <mf at openxp dot uk> 5.0.32-1
- New version (5.0.32)

* Sat May 06 2017 M.E.Foster <mf at openxp dot uk> 5.0.31-1
- New version (5.0.31)

* Sat Sep 10 2016 M.E.Foster <mf at openxp dot uk> 5.0.28-1
- New version (5.0.28)

* Sun Aug 21 2016 M.E.Foster <mf at openxp dot uk> 5.0.27-3
- Development build
- Compiler updated to 3.0.0
- Now building on Mageia

* Tue Apr 26 2016 M.E.Foster <mf at openxp dot uk> 5.0.27-2
- Compiler reverted to 2.6.4
- binkP handshake failure fixed

* Sat Apr 23 2016 M.E.Foster <mf at openxp dot uk> 5.0.27-1
- New version (5.0.27)

* Mon Jan 18 2016 M.E.Foster <mf at openxp dot uk> 5.0.26-2
- Development build
- Compiler updated to 3.0.0

* Sat Jan 02 2016 M.E.Foster <mf at openxp dot uk> 5.0.26-1
- New version (5.0.26)

* Sat Dec 12 2015 M.E.Foster <mf at openxp dot uk> 5.0.25-2
- Development build

* Sat Nov 21 2015 M.E.Foster <mf at openxp dot uk> 5.0.25-1
- New version (5.0.25)

* Thu Oct 08 2015 M.E.Foster <mf at openxp dot uk> 5.0.24-1
- Development build (5.0.24)

* Fri Sep 18 2015 M.E.Foster <mf at openxp dot uk> 5.0.23-1
- New version (5.0.23)

* Sat Apr 04 2015 M.E.Foster <mf at openxp dot org dot uk> 5.0.22-1
- New version (5.0.22)
- First public 64-bit Linux release

* Sun Mar 22 2015 M.E.Foster <mf at openxp dot org dot uk> 5.0.21-1
- Development version (5.0.21)

* Fri Jan 30 2015 M.E.Foster <mf at openxp dot org dot uk> 5.0.20-1
- New version (5.0.20)

* Sun Dec 21 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.19-1
- New version (5.0.19)

* Tue Dec 09 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.18-2
- Problem with German umlauts in POP3/IMAP fixed

* Sat Dec 06 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.18-1
- New version (5.0.18)

* Fri Nov 28 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.17-2
- Problem with libtinfo fixed

* Mon Nov 10 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.17-1
- New version (5.0.17)
- Compiler is now at version 2.6.4

* Sat May 10 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.16-1
- New version (5.0.16)

* Sat Mar 15 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.15-1
- New version (5.0.15)

* Sat Mar 01 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.14-1
- New version (5.0.14)

* Sun Feb 09 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.10-1
- New version (5.0.10)

* Sat Feb 08 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.9-1
- New version (5.0.9)

* Sat Jan 04 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.7-1
- New version (5.0.7)

* Thu Jan 02 2014 M.E.Foster <mf at openxp dot org dot uk> 5.0.6-1
- New version (5.0.6)

* Tue Dec 31 2013 M.E.Foster <mf at openxp dot org dot uk> 5.0.5-1
- OpenXP5 is here
- Compiler is now at version 2.6.2

* Tue Mar 13 2012 M.E.Foster <mf at openxp dot org dot uk> 4.10.7372-1
- First PUBLIC build

* Tue Mar 13 2012 M.E.Foster <mf at openxp dot org dot uk> 4.10.7372
- Final clean-up of SPECFILE
- Final TEST build
- Thunderbirds are GO! :-))

* Mon Mar 05 2012 M.E.Foster <mf at openxp dot org dot uk> 4.10.7372
- Cleaned up the SPECFILE some more
- Third TEST build

* Thu Feb 23 2012 M.E.Foster <mf at openxp dot org dot uk> 4.10.7372
- Cleaned up the SPECFILE a bit
- Added the missing example English message templates
- Second TEST build

* Wed Feb 22 2012 M.E.Foster <mf at openxp dot org dot uk> 4.10.7372
- Original OpenXP-Team SPECFILE adapted to suit "modern" Linux distributions
- First TEST build
