{   $Id: xp_uue.pas 7156 2005-11-05 17:21:04Z mkaemmerer $

    OpenXP UU decoding unit
    Copyright (C) 1991-2001 Peter Mandrella
    Copyright (C) 2000-2002 OpenXP team (www.openxp.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

{$I xpdefine.inc}

{ OpenXP UU decoding unit }
unit xp_uue;


interface

uses
  sysutils,
{$IFDEF NCRT }
  xpcurses,
{$ENDIF }
  typeform,fileio,inout,database,maus2,resource,
  winxp, xp0,xp1,xp1o,xp1o2,xp1input, xpglobal;


procedure uudecode;            { aktuelle Nachricht decodieren }

function uudecfile(infile,outpath:string; wait:boolean):boolean;


implementation

uses xpheader, xp3,xp3ex;

const obufsize = 12288; { Auf 32 Byte Gren angepasst }
      ibufsize = 16384;
      maxbuf   : LongWord = obufsize-4;

type  buffer = array[0..50000] of byte;
      bufptr = ^buffer;

var   s        : string;
      shorts   : ShortString;
      f1,f2    : file;
      bufp     : LongWord;
      outbuf,
      inbuf    : bufptr;
      ibufp,
      ibufend  : Integer;
      ln,bytes : longint;
      EOFinput : boolean;
      IO_Error : boolean;


procedure flushbuf;                   {JG:08.02.00 Verschoben: wird von Decode aufgerufen...}
begin
  if IO_error then exit;
  blockwrite(f2,outbuf^,bufp);
  if inoutres<>0 then begin
    fehler(ioerror(ioresult,getres2(10000,10)));
    IO_error:=true;
    end;
  bufp:=0;
end;

{ !! Ungetestet und unoptimiert }
procedure decode; assembler; asm
{$IFDEF CPUX86_64 }
          push rbx
          push rsi
          push rdi
          lea rsi,ShortS[rip]     { Adresse des zu dekod. Strings }
          mov rbx,2               { Offset innerhalb von s }

          mov cl,1                { Schleifenzhler }
          mov ch,[rsi+1]          { 1. Byte : Lngeninformation }
          sub ch,' '
          and ch,3fh

@mloop0:  mov edi,bufp[rip]
          add rdi,outbuf[rip]     { Adresse des Ausgabepuffers }

@mainloop:
          cmp cl,ch               { i<=n ? }
          jbe @lp1
          inc ln[rip]
          xor rax, rax
          mov al,ch
          add bytes[rip], eax
          jmp @ende

@lp1:     mov dx,[rsi+rbx]        { 4 Bytes dekodieren }
          sub dx,2020h
          mov ax,[rsi+rbx+2]
          sub ax,2020h
          add ebx,4
          shl al,1
          shl al,1
          shl al,1
          rcl dh,1
          shl al,1
          rcl dh,1
          shl al,1
          rcl dh,1
          rcl dl,1
          shl al,1
          rcl dh,1
          rcl dl,1
          and ah,3fh
          add al,ah
          mov [rdi],dx
          add rdi,2
          mov [rdi],al
          add rdi,1

          mov eax,bufp[rip]
          inc cl
          inc eax
          cmp cl,ch
          ja @zende
          inc cl
          inc eax
          cmp cl,ch
          ja @zende
          inc cl
          inc eax
@zende:   mov bufp[rip],eax
          cmp eax,maxbuf[rip]
          ja @flush
          jmp @mainloop

@flush:   push rcx
          call flushbuf           { setzt bufp auf 0   JG:FAR }
          pop rcx
          jmp @mloop0
@ende:    pop rdi
          pop rsi
          pop rbx
{$ELSE }
          push ebx
          push esi
          push edi
          lea esi, ShortS         { Adresse des zu dekod. Strings }
          mov ebx, 2              { Offset innerhalb von s }

          mov cl,1                { Schleifenzhler }
          mov ch,[esi+1]          { 1. Byte : Lngeninformation }
          sub ch,' '
          and ch,3fh

@mloop0:  mov edi,outbuf          { Adresse des Ausgabepuffers }
          add edi,bufp

@mainloop:
          cmp cl,ch               { i<=n ? }
          jbe @lp1
          inc ln
          xor eax, eax
          mov al,ch
          add bytes, eax
          jmp @ende

@lp1:     mov dx,[esi+ebx]        { 4 Bytes dekodieren }
          sub dx,2020h
          mov ax,[esi+ebx+2]
          sub ax,2020h
          add ebx,4
          shl al,1
          shl al,1
          shl al,1
          rcl dh,1
          shl al,1
          rcl dh,1
          shl al,1
          rcl dh,1
          rcl dl,1
          shl al,1
          rcl dh,1
          rcl dl,1
          and ah,3fh
          add al,ah
          mov [edi],dx
          inc edi
          inc edi
          mov [edi],al
          inc edi

          mov eax,bufp
          inc cl
          inc eax
          cmp cl,ch
          ja @zende
          inc cl
          inc eax
          cmp cl,ch
          ja @zende
          inc cl
          inc eax
@zende:   mov bufp,eax
          cmp eax,maxbuf
          ja @flush
          jmp @mainloop

@flush:   pushad
          call flushbuf           { setzt bufp auf 0   JG:FAR }
          popad
          jmp @mloop0
@ende:    pop edi
          pop esi
          pop ebx
{$ENDIF }
end;

procedure getstring; assembler; asm
{$IFDEF CPUX86_64 }
          push rbx
          push rsi
          push rdi
          mov rsi,inbuf[rip]
          mov ebx,ibufp[rip]
          lea rdi,ShortS[rip]
          inc rdi
          mov edx,ibufend[rip]
          mov ah,0

@getloop: cmp rbx,rdx             { ibufp > ibufend ? }
          ja  @getende
          mov al,[rsi+rbx]
          cmp al,' '              { Zeilenende ? }
          jb  @getok
          mov [rdi],al
          inc rdi
          inc rbx
          inc ah
          cmp ah,100              { max. Stringlnge }
          jb  @getloop
@getok:   mov al,2                { max. ein CR/LF berlesen }
@getok2:  cmp rbx,rdx             { ibufp > ibufend ? }
          ja @getende
          cmp byte ptr [rsi+rbx],' '
          jae @getende
          inc rbx                 { Zeilenvorschbe berlesen }
          dec al
          jnz @getok2

@getende: mov ibufp[rip],ebx
          lea rdi,ShortS[rip]
          mov [rdi],ah            { Stringlnge setzen (s[0]) }
          pop rdi
          pop rsi
          pop rbx
{$ELSE }
          push ebx
          push esi
          push edi
          mov esi,inbuf
          mov ebx,ibufp
          lea edi,ShortS
          inc edi
          mov edx,ibufend
          mov ah,0

@getloop: cmp ebx,edx             { ibufp > ibufend ? }
          ja  @getende
          mov al,[esi+ebx]
          cmp al,' '              { Zeilenende ? }
          jb  @getok
          mov [edi],al
          inc edi
          inc ebx
          inc ah
          cmp ah,100              { max. Stringlnge }
          jb  @getloop
@getok:   mov al,2                { max. ein CR/LF berlesen }
@getok2:  cmp ebx,edx             { ibufp > ibufend ? }
          ja @getende
          cmp byte ptr [esi+ebx],' '
          jae @getende
          inc ebx                 { Zeilenvorschbe berlesen }
          dec al
          jnz @getok2

@getende: mov ibufp,ebx
          lea edi,ShortS
          mov [edi],ah            { Stringlnge setzen (s[0]) }
          pop edi
          pop esi
          pop ebx
{$ENDIF }
end;

procedure ReadInputLine;
const
  ibufmin   = 255;
var
  bytesread : Integer;
begin
  if ibufend<ibufp then begin
    blockread(f1,inbuf^,ibufsize-5,bytesread);
    if bytesread=0 then begin
      ibufend:=0; EOFinput:=true;
      end
    else ibufend:=bytesread-1;
    ibufp:=0;
    end
  else if ibufend<ibufp+ibufmin then begin
    Move(inbuf^[ibufp],inbuf^[0],ibufend-ibufp+1);
    dec(ibufend,ibufp); ibufp:=0;
    blockread(f1,inbuf^[ibufend+1],ibufsize-ibufend-5,bytesread);
    inc(ibufend,bytesread);
    end;
  if ibufend<ibufp then EOFinput:=true
  else
  begin
    getstring;        { String aus inbuf^[ibufp] --> s lesen }
    s := shorts;
  end;
end;



{ f1 -> mit Assign zugewiesene Eingabedatei }
{ fn <- Dateiname aus der 'begin'-Zeile     }

function openinfile(var f1:file; var fn:String; goon:boolean):boolean;
var found: boolean;
    p    : byte;
begin
  if not goon then begin
    reset(f1,1); ibufp:=1; ibufend:=0; EOFinput:=false;
  end;
  repeat
    ReadInputLine;
    found:=(LeftStr(s,5)='begin');
  until EOFinput or found;
  p:=posn(' ',s,7);
  if p=0 then fn:=''
  else fn:=FileUpperCase(trim(mid(s,p)));
  openinfile:=found and (fn<>'');
  if EOFinput then exit;
end;

procedure opencontfile(var f1:file);
begin
  reset(f1,1); ibufp:=1; ibufend:=0; EOFinput:=false;
end;


procedure uudecIt(var f1:file; outfile:string; wait:boolean;
                  filenr,filetotal:integer; overwrite:boolean);
const x : Integer = 0;
      y : Integer = 0;

var ende : boolean;
    size : longint;
    start: boolean;
    l    : longint;
    warn : boolean;

  procedure showze;
  begin
    moff;
    gotoxy(x+23,y+2); write(filenr:3);
    gotoxy(x+35,y+2); write(ln:5);
    gotoxy(x+42,y+2); write(bytes:8);
    mon;
  end;

begin
  if filenr=1 then begin
    msgbox(59,5,'uudecode',x,y);
    mwrt(x+3,y+2,getres(2400));   { 'decodiere Nachricht     / Zeile       /         Bytes' }
    end;
  attrtxt(col.colmboxhigh);
  assign(f2,outfile);
  if overwrite then
    rewrite(f2,1)
  else begin
    reset(f2,1);               { an vorhandene Teile anhngen }
    seek(f2,filesize(f2));
    end;
  ln:=0; bufp:=0;
  start:=true;
  warn:=false;
  repeat
    if start and (filenr>1) then
      repeat
        ReadInputline
      until ((s<>'') and (s[1]='M')) or EOFinput
    else
      ReadInputLine;
    ende:=(LeftStr(s,3)='end');
    if length(s)>1 then
      if (s[1]<='_') and (s[1]>='!') and not ende then begin
        if length(s)<((ord(s[1])-32) div 3 * 4)+1 then begin
          if not warn and (filenr=filetotal) then begin
            hinweis(getres(2405));  { 'Warnung: Fehlerhafte Zeile; decodierte Datei ist evtl. fehlerhaft' }
            warn:=true;
            end;
          s:=forms(s,((ord(s[1])-32) div 3 * 4)+1);
          end;
        begin
          shorts := s;
          decode;
        end;
        end
      else
        if filenr<filetotal then ende:=true;
    if ln mod 10 = 0 then showze;
    start:=false;
  until EOFinput or IO_error or ende or ((filenr<filetotal) and (s=''));
  if bufp>0 then flushbuf;
  if not EOFinput then begin           { 'size' auswerten }
    ReadInputLine;
    if LeftStr(s,4)='size' then begin
      size:=ival(mid(s,5));
      if (size>0) and (size<filesize(f2)) then begin
        seek(f2,size);
        truncate(f2);
        end;
      end
    else
      {:  sum -r/size 49243/2336 section (from "begin" to "end")  }
      {:  sum -r/size 34783/1676 entire input file                }
      while (LeftStr(s,12)='sum -r/size ') and not EOFinput do begin
        if pos('entire',s)>0 then begin
          s:=trim(mid(s,13));
          ival(GetToken(s,'/'));   { Summe berlesen }
          l:=ival(GetToken(s,' '));
          if (l<filesize(f2)) and (l>filesize(f2)-20) then begin
            seek(f2,l);
            truncate(f2);
            end;
          end;
        ReadInputline;
        end;
    end;
  close(f2);
  showze;
  if filenr=filetotal then begin
    if wait then
      wkey(1,false);
    closebox;
    end;
end;


procedure uudecode;
const maxuumark= 100;       { max. decodierbare, markierte Einzelteile }
      fldDatum = 1;
      fldIntnr = 2;
      fldSection = 3;
type  uumarkrec = record
                    recno   : longint;
                    sortfld : array[1..3] of longint;
                  end;

var tmp,fn   : string;
    useclip  : boolean;
    brk      : boolean;
    decmark  : boolean;
    marklist : array[1..maxuumark] of uumarkrec;
    mlanz    : integer;
    i        : integer;
    ok       : boolean;
    msize    : longint;
    hdp      : Theader;
    hds      : longint;
    o        : boolean;
    Filenr   : byte;
    dBpos    : longint;

  procedure SortFor(fld:integer);
  var i,j : integer;
      w   : uumarkrec;
  begin
    for i:=mlanz downto 2 do
      for j:=1 to i-1 do
        if marklist[j].sortfld[fld]>marklist[j+1].sortfld[fld] then begin
          w:=marklist[j]; marklist[j]:=marklist[j+1]; marklist[j+1]:=w;
          end;
    ok:=true;                               { Test auf doppeltes Datum }
    for i:=1 to mlanz-1 do
      if marklist[i].sortfld[fld]=marklist[i+1].sortfld[fld] then
        ok:=false;
  end;

  procedure GetMsize;                 { Nachrichten-Maximalgre berechnen }
  var i : integer;
  begin
    msize:=0;
    for i:=1 to mlanz do begin
      dbGo(mbase,marklist[i].recno);
      msize:=max(msize,dbReadInt(mbase,'groesse'));
      end;
    tmp:=TempS(msize);
  end;

  procedure ReadSections;             { Section-Nummern einlesen }
  const tbs = 4096;
  var i  : integer;
      t  : text;
      s  : string;
      tb : pointer;
      p  : byte;
  begin
    ok:=true;
    getmem(tb,tbs);
    i:=1;
    while (i<=mlanz) and ok do begin
      dbGo(mbase,marklist[i].recno);
      extract_msg(0,'',tmp,false,0);
      assign(t,tmp); settextbuf(t,tb^,tbs);
      reset(t); s:='';
      while not eof(t) and (LeftStr(s,8)<>'section ') do
        readln(t,s);
      close(t);
      if LeftStr(s,8)='section ' then begin
        s:=trim(mid(s,9));
        p:=blankpos(s);
        if p>0 then marklist[i].sortfld[fldSection]:=ival(LeftStr(s,p-1));
        end;
      if marklist[i].sortfld[fldSection]=0 then ok:=false;
      inc(i);
      end;
    freemem(tb,tbs);
  end;

begin
  dbpos:=dbrecno(mbase);
  if markanz=0 then
    decmark:=false
  else begin
    pushhp(11202);
    decmark:=ReadJNesc(GetReps(2403,strs(markanz)),true,brk);  { '%s markierte Nachrichten decodieren' }
    pophp;
    if brk then exit;
    if decmark and (markanz>maxuumark) then begin
      rfehler1(2404,strs(maxuumark));   { 'Es knnen maximal %s markierte Einzelteile decodiert werden.' }
      exit;
      end;
    end;
  if decmark then begin
    mlanz:=markanz;
    moment;
    hdp := THeader.Create;
    sortmark;
    for i:=1 to mlanz do begin              { Liste der Nachrichten nach }
      marklist[i].recno:=marked^[i-1].recno;  { Datum sortieren            }
      dbGo(mbase,marklist[i].recno);
      ReadHeader(hdp,hds,ok);              { Sekunden dazuaddieren      }
      marklist[i].sortfld[fldDatum]:=(ixdat(hdp.datum) and $ffffff) shl 7 +
                                     ival(copy(hdp.zdatum,13,2));
      marklist[i].sortfld[fldIntnr]:=dbReadInt(mbase,'int_nr');
      marklist[i].sortfld[fldSection]:=0;
      end;
    unsortmark;
    Hdp.Free;
    GetMsize;
    ReadSections;
    if ok then SortFor(fldSection);
    if not ok then SortFor(fldDatum);
    closebox;
    if not ok then begin
      hinweis(getres(2404));   { 'Warnung: Reihenfolge kann nicht zuverlssig ermittelt werden.' }
      SortFor(fldIntnr);
      end;
    end
  else begin
    mlanz:=1;
    marklist[1].recno:=dbRecno(mbase);     { Datum ist egal }
    GetMsize;
    end;

  dbGo(mbase,marklist[1].recno);
  extract_msg(0,'',tmp,false,0);
  assign(f1,tmp);
  getmem(inbuf,ibufsize);
  getmem(outbuf,obufsize);
  if not openinfile(f1,fn,false) then
    rfehler(2402)    { 'Nachricht enthlt keine UUcodierte Datei' }
  else begin
    Filenr:=0;
    repeat

    inc(Filenr);
    pushhp(75);
    useclip:=false;
    if ReadFilename(getres(2402)+iifs(filenr>1,' '+strs(filenr),''),fn,true,useclip)
    then begin                                            { 'Zieldatei' }
      if not multipos(_MPMask,fn) then fn:=ExtractPath+fn;
      if FileExists(fn) then o:=overwrite(fn,true,brk)
      else o:=true;
      if not FileExists(fn) or not brk then begin
        bytes:=0;
        IO_error:=false;
        uudecIt(f1,fn,true,1,mlanz,o);
        if IO_error and (mlanz>1) then
          closebox
        else begin
          i:=2;
          while (i<=mlanz) and not IO_error do begin
            close(f1);
            dbGo(mbase,marklist[i].recno);
            extract_msg(0,'',tmp,false,0);
            OpenContFile(f1);
            uudecIt(f1,fn,true,i,mlanz,false);
            inc(i);
            end;
          if i<mlanz then closebox;   { IO_error }
          end;
        end;
      end;
    pophp;

    until (mlanz>1) or not openinfile(f1,fn,true);
  end;
  close(f1);
  _era(tmp);
  freemem(outbuf,obufsize);
  freemem(inbuf,ibufsize);
  dbgo(mbase,dbpos);
end;


function uudecfile(infile,outpath:string; wait:boolean):boolean;
var fn : string;
begin
  uudecfile:=false;
  assign(f1,infile);
  getmem(inbuf,ibufsize);
  getmem(outbuf,obufsize);
  if not openinfile(f1,fn, false) then
    trfehler(2403,20)    { 'Kann Datei nicht decodieren.' }
  else begin
    uudecit(f1,outpath+fn,wait,1,1,true);
    uudecfile:=true;
    end;
  close(f1);
  freemem(outbuf,obufsize);
  freemem(inbuf,ibufsize);
end;

end.
